/**
 * 是否实名
 */
export declare enum HasRealNameEnum {
    "无实名信息" = "false",
    "有实名信息" = "true"
}
/**
 * 账户是/否签约
 */
export declare enum SignFlagEnum {
    "未签约" = 0,
    "已签约" = 1
}
/**
 * 证件类型
 * @description 对应中台字典
 */
export declare enum IdTypeEnum {
    "身份证" = 0,
    "护照" = 1,
    "军官证" = 2,
    "士兵证" = 3,
    "回乡证" = 4,
    "户口本" = 5,
    "外国护照" = 6,
    "其他" = 7,
    "文职证" = 8,
    "警官证" = 9,
    "港澳居民来往内地通行证" = 10,
    "台湾居民来往内地通行证" = 11,
    "港澳台居民身份证" = 12,
    "_港澳台居民身份证" = 13,
    "社会保障号" = 14,
    "港澳台居民居住证" = 15,
    "技术监督局代码" = 20,
    "营业执照" = 21,
    "行政机关" = 22,
    "社会团体" = 23,
    "军队" = 24,
    "武警" = 25,
    "下属机构" = 26,
    "基金会" = 27,
    "登记证书" = 31,
    "外国人永久居留证" = 33,
    "武警证" = "A1",
    "台胞证" = "A2",
    "其他(机构)" = "B1",
    "组织机构代码证" = "B2"
}
