import { SignFlagEnum } from "./CommonEnum";
/**
 * 账户类型接口
 */
export interface IAccount {
    /**
     * 客户名称
     */
    clientName: string;
    /**
     * 客户号
     */
    clientId: string;
    /**
     * 系统号
     */
    bizSysId: string;
    /**
     * 资金账号
     */
    fundAccount: string;
    /**
     * 是否签约
     */
    signFlag: SignFlagEnum;
}
/**
 * 账户
 */
interface IIF010016Resolve {
    /**
     * 账户列表
     */
    accounts: IAccount[];
}
/**
 * 获取键值映射表
 * @returns
 */
export declare const IF010016: () => Promise<IIF010016Resolve & {
    header: TaroGeneral.IAnyObject;
    cookies?: string[] | undefined;
}>;
export {};
