var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
      }
    };
    return _extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    _extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();
var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var __generator = this && this.__generator || function (thisArg, body) {
  var _ = {
      label: 0,
      sent: function sent() {
        if (t[0] & 1) throw t[1];
        return t[1];
      },
      trys: [],
      ops: []
    },
    f,
    y,
    t,
    g;
  return g = {
    next: verb(0),
    "throw": verb(1),
    "return": verb(2)
  }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {
    return this;
  }), g;
  function verb(n) {
    return function (v) {
      return step([n, v]);
    };
  }
  function step(op) {
    if (f) throw new TypeError("Generator is already executing.");
    while (g && (g = 0, op[0] && (_ = 0)), _) {
      try {
        if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
        if (y = 0, t) op = [op[0] & 2, t.value];
        switch (op[0]) {
          case 0:
          case 1:
            t = op;
            break;
          case 4:
            _.label++;
            return {
              value: op[1],
              done: false
            };
          case 5:
            _.label++;
            y = op[1];
            op = [0];
            continue;
          case 7:
            op = _.ops.pop();
            _.trys.pop();
            continue;
          default:
            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
              _ = 0;
              continue;
            }
            if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
              _.label = op[1];
              break;
            }
            if (op[0] === 6 && _.label < t[1]) {
              _.label = t[1];
              t = op;
              break;
            }
            if (t && _.label < t[2]) {
              _.label = t[2];
              _.ops.push(op);
              break;
            }
            if (t[2]) _.ops.pop();
            _.trys.pop();
            continue;
        }
        op = body.call(thisArg, _);
      } catch (e) {
        op = [6, e];
        y = 0;
      } finally {
        f = t = 0;
      }
    }
    if (op[0] & 5) throw op[1];
    return {
      value: op[0] ? op[1] : void 0,
      done: true
    };
  }
};
var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) {
      ar.push(r.value);
    }
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
/*
 * @Author: jiangxin
 * @Date: 2021-04-20 10:23:48
 * @Company: orientsec.com.cn
 * @Description: web 版本二级登录检查
 */
// 相关API
import Base from "./base";
import { IF115016 } from "./services/IF115016";
import { IF010016 } from "./services/IF010016";
import { IF010048 } from "./services/IF010048";
// 基础函数
// import createHref from "common/gateway";
import { HasRealNameEnum, SignFlagEnum } from "./services/CommonEnum";
import Taro, { showModal, showLoading, hideLoading } from "@tarojs/taro";
// 弹框组件
import { CommonShowModal } from "./DFModal/commonModal";
import { OpenAccountModal } from "./DFModal/openAccountModal";
import { ShowBindPanel } from "./DFModal/showBindPanel";
var TwiceLogin = /** @class */function (_super) {
  __extends(TwiceLogin, _super);
  /**
   * 构建二次登录实例
   * @param params {
   *    success: @function,  // 成功回调函数(验证通过和无需验证都会执行该回调)
   *    failure: @function,  // 失败回调函数(验证交易密码之类的业务异常时才会回调该函数)
   * }
   * @param {function} params.doWhenWithoutAccount   如果没有资金账户的回调 返回true 依然是调用默认流程 返回false或者undefined 不再执行默认流程
   */
  function TwiceLogin(params) {
    if (params === void 0) {
      params = Object.create(null);
    }
    var _this = _super.call(this) || this;
    /**
     * 执行登录/签约
     * @param params
     * @returns
     */
    _this.submit = function (params) {
      return __awaiter(_this, void 0, void 0, function () {
        var _fundAccount, _needSign, password, error_1;
        return __generator(this, function (_a) {
          switch (_a.label) {
            case 0:
              showLoading({
                title: "加载中..."
              });
              if (this.selectAccount == null) throw new Error("所选账户为空");
              _a.label = 1;
            case 1:
              _a.trys.push([1, 3, 4, 5]);
              _fundAccount = this.selectAccount.fundAccount;
              _needSign = this.selectAccount.signFlag;
              password = params.password;
              return [4 /*yield*/, IF010048({
                fundAccount: _fundAccount,
                password: password,
                needSign: _needSign,
                expiredSeconds: Base.expiredSeconds
              })];
            case 2:
              _a.sent();
              // 存储当前账户为默认账户(Base.setDefaultAccount实现了数据归档)
              Base.setDefaultAccount(_fundAccount);
              // 执行成功回调
              this.success(this.selectAccount);
              return [3 /*break*/, 5];
            case 3:
              error_1 = _a.sent();
              this.failure(error_1);
              showModal({
                title: TwiceLogin.tip,
                content: error_1.info,
                showCancel: false,
                confirmText: "取消"
              });
              return [3 /*break*/, 5];
            case 4:
              hideLoading();
              this.triggerCloseTwoLogin();
              return [7 /*endfinally*/];
            case 5:
              return [2 /*return*/];
          }
        });
      });
    };

    _this.success = (params === null || params === void 0 ? void 0 : params.success) || function () {
      return void 0;
    };
    _this.failure = (params === null || params === void 0 ? void 0 : params.failure) || function () {
      return void 0;
    };
    _this.cancel = (params === null || params === void 0 ? void 0 : params.cancel) || function () {
      return void 0;
    };
    _this.doWhenWithoutAccount = (params === null || params === void 0 ? void 0 : params.doWhenWithoutAccount) || function () {
      return true;
    };
    // 注册全局事件
    // 注册点击键盘确认按钮事件
    Taro.eventCenter.off("toSubmitLogin");
    Taro.eventCenter.on("toSubmitLogin", _this.submit.bind(_this));
    // 注册全局事件
    // 注册点击键盘关闭按键事件
    Taro.eventCenter.off("keyBoardClose");
    Taro.eventCenter.on("keyBoardClose", _this.keyBoardCancle.bind(_this));
    return _this;
  }
  /**
   * 键盘取消
   */
  TwiceLogin.prototype.keyBoardCancle = function () {
    this.cancel();
  };
  /**
   * 过滤账户
   */
  TwiceLogin.prototype.filterAcount = function (element) {
    return TwiceLogin.filterAccouts.includes(element.bizSysId);
  };
  /**
   * 过滤出签约账户
   * @param element
   */
  TwiceLogin.prototype.filterContract = function (element) {
    return element.signFlag == SignFlagEnum.已签约;
  };
  /**
   * 打开登录面板
   */
  TwiceLogin.prototype.triggerTwoLogin = function () {
    Taro.eventCenter.trigger("openTwoLogin", __assign({}, this.selectAccount));
  };
  /**
   * 关闭登录面板
   */
  TwiceLogin.prototype.triggerCloseTwoLogin = function () {
    Taro.eventCenter.trigger("closeTwoLogin");
  };
  /**
   * 二次登录的处理
   * @private
   */
  TwiceLogin.prototype.toLogin = function () {
    return __awaiter(this, void 0, void 0, function () {
      var _a, IF115016Data, IF010016Data, hasRealName, accounts, _availableAccounts, _defaultAccount_1, _filtered, _selectAccountIndex, defaultAccountInfo, _selectAccountIndex, _isExpire, error_2;
      return __generator(this, function (_b) {
        switch (_b.label) {
          case 0:
            showLoading({
              title: "加载中..."
            });
            _b.label = 1;
          case 1:
            _b.trys.push([1, 14, 15, 16]);
            return [4 /*yield*/, Promise.all([IF115016(), IF010016()])];
          case 2:
            _a = __read.apply(void 0, [_b.sent(), 2]), IF115016Data = _a[0], IF010016Data = _a[1];
            hasRealName = IF115016Data.hasRealName;
            accounts = IF010016Data.accounts;
            hideLoading();
            if (!(String(hasRealName) === HasRealNameEnum.无实名信息)) return [3 /*break*/, 4];
            return [4 /*yield*/, CommonShowModal({
              title: TwiceLogin.tip,
              content: TwiceLogin.notRealNameInfo,
              confirmText: TwiceLogin.goToRealNameFlow,
              cancel: this.failure
            })];
          case 3:
            _b.sent();
            _b.label = 4;
          case 4:
            if (!(String(hasRealName) === HasRealNameEnum.有实名信息)) return [3 /*break*/, 13];
            _availableAccounts = accounts.filter(this.filterAcount);
            console.log("指定类型账户", _availableAccounts);
            if (!(_availableAccounts.length === 0 && this.doWhenWithoutAccount() !== false)) return [3 /*break*/, 6];
            return [4 /*yield*/, OpenAccountModal()];
          case 5:
            _b.sent();
            _b.label = 6;
          case 6:
            if (!(_availableAccounts.length > 0)) return [3 /*break*/, 13];
            _defaultAccount_1 = Base.getDefaultAccount();
            console.log("默认账户", _defaultAccount_1);
            if (!!_defaultAccount_1) return [3 /*break*/, 10];
            _filtered = accounts.filter(this.filterContract);
            if (!(_filtered.length === 1)) return [3 /*break*/, 7];
            // 设置所选择的账户
            this.selectAccount = _filtered[0];
            this.triggerTwoLogin();
            return [3 /*break*/, 9];
          case 7:
            return [4 /*yield*/, ShowBindPanel({
              data: accounts.map(function (m) {
                return m.fundAccount;
              })
            })];
          case 8:
            _selectAccountIndex = _b.sent();
            // 设置所选择的账户
            this.selectAccount = accounts[_selectAccountIndex];
            console.log("所选账号", this.selectAccount);
            this.triggerTwoLogin();
            _b.label = 9;
          case 9:
            return [3 /*break*/, 13];
          case 10:
            defaultAccountInfo = accounts.find(function (n) {
              return n.fundAccount == _defaultAccount_1.key;
            });
            if (!!defaultAccountInfo) return [3 /*break*/, 12];
            return [4 /*yield*/, ShowBindPanel({
              data: accounts.map(function (m) {
                return m.fundAccount;
              })
            })];
          case 11:
            _selectAccountIndex = _b.sent();
            // 设置所选择的账户
            this.selectAccount = accounts[_selectAccountIndex];
            console.log("所选账号", this.selectAccount);
            this.triggerTwoLogin();
            return [3 /*break*/, 13];
          case 12:
            // 设置所选择的账户
            this.selectAccount = defaultAccountInfo;
            if (defaultAccountInfo.signFlag == SignFlagEnum.未签约) {
              this.triggerTwoLogin();
            }
            if (defaultAccountInfo.signFlag == SignFlagEnum.已签约) {
              _isExpire = this.isExpire();
              if (_isExpire) {
                this.triggerTwoLogin();
              } else {
                this.success(defaultAccountInfo);
              }
            }
            _b.label = 13;
          case 13:
            return [3 /*break*/, 16];
          case 14:
            error_2 = _b.sent();
            console.log("错误信息", error_2);
            error_2 && showModal({
              title: TwiceLogin.tip,
              content: error_2.info,
              showCancel: false,
              confirmText: "取消"
            });
            return [3 /*break*/, 16];
          case 15:
            hideLoading();
            return [7 /*endfinally*/];
          case 16:
            return [2 /*return*/];
        }
      });
    });
  };

  TwiceLogin.tip = "提示";
  TwiceLogin.notRealNameInfo = "为了给您提供更好的服务，请先完成实名认证";
  TwiceLogin.cancel = "取消";
  TwiceLogin.goToRealNameFlow = "去实名";
  TwiceLogin.certain = "确认";
  // 需要包含的账户类型
  TwiceLogin.filterAccouts = ["3", "6", "18"];
  return TwiceLogin;
}(Base);
export { TwiceLogin };