/*
 * @Author: jiangxin
 * @Date: 2021-04-20 09:54:40
 * @Company: orientsec.com.cn
 * @Description:
 */
import { longLogin } from "fastman3-dfyjapp-longlogin/es/index";
import { TwiceLogin } from "./twiceLogin";
import { AppAuthorize } from 'fastman3-dfyjapp-jsbridge';
export var shortLogin = function shortLogin(params) {
  return longLogin().then(function (res) {
    return new Promise(function (resolve, reject) {
      new TwiceLogin({
        success: function success(arg) {
          // 同步更新 AppAuthorize 数据
          AppAuthorize.fundAccount = arg === null || arg === void 0 ? void 0 : arg.fundAccount;
          AppAuthorize.clientName = arg === null || arg === void 0 ? void 0 : arg.clientName;
          AppAuthorize.bizSysId = arg === null || arg === void 0 ? void 0 : arg.bizSysId;
          resolve(arg);
        }
      }).toLogin();
    });
  });
};