/*
 * @Author: jiangxin
 * @Date: 2021-04-20 10:06:27
 * @Company: orientsec.com.cn
 * @Description: 通用枚举
 */
/**
 * 是否实名
 */
export var HasRealNameEnum;
(function (HasRealNameEnum) {
  HasRealNameEnum["\u65E0\u5B9E\u540D\u4FE1\u606F"] = "false";
  HasRealNameEnum["\u6709\u5B9E\u540D\u4FE1\u606F"] = "true";
})(HasRealNameEnum || (HasRealNameEnum = {}));
/**
 * 账户是/否签约
 */
export var SignFlagEnum;
(function (SignFlagEnum) {
  SignFlagEnum[SignFlagEnum["\u672A\u7B7E\u7EA6"] = 0] = "\u672A\u7B7E\u7EA6";
  SignFlagEnum[SignFlagEnum["\u5DF2\u7B7E\u7EA6"] = 1] = "\u5DF2\u7B7E\u7EA6";
})(SignFlagEnum || (SignFlagEnum = {}));
/**
 * 证件类型
 * @description 对应中台字典
 */
export var IdTypeEnum;
(function (IdTypeEnum) {
  IdTypeEnum[IdTypeEnum["\u8EAB\u4EFD\u8BC1"] = 0] = "\u8EAB\u4EFD\u8BC1";
  IdTypeEnum[IdTypeEnum["\u62A4\u7167"] = 1] = "\u62A4\u7167";
  IdTypeEnum[IdTypeEnum["\u519B\u5B98\u8BC1"] = 2] = "\u519B\u5B98\u8BC1";
  IdTypeEnum[IdTypeEnum["\u58EB\u5175\u8BC1"] = 3] = "\u58EB\u5175\u8BC1";
  IdTypeEnum[IdTypeEnum["\u56DE\u4E61\u8BC1"] = 4] = "\u56DE\u4E61\u8BC1";
  IdTypeEnum[IdTypeEnum["\u6237\u53E3\u672C"] = 5] = "\u6237\u53E3\u672C";
  IdTypeEnum[IdTypeEnum["\u5916\u56FD\u62A4\u7167"] = 6] = "\u5916\u56FD\u62A4\u7167";
  IdTypeEnum[IdTypeEnum["\u5176\u4ED6"] = 7] = "\u5176\u4ED6";
  IdTypeEnum[IdTypeEnum["\u6587\u804C\u8BC1"] = 8] = "\u6587\u804C\u8BC1";
  IdTypeEnum[IdTypeEnum["\u8B66\u5B98\u8BC1"] = 9] = "\u8B66\u5B98\u8BC1";
  IdTypeEnum[IdTypeEnum["\u6E2F\u6FB3\u5C45\u6C11\u6765\u5F80\u5185\u5730\u901A\u884C\u8BC1"] = 10] = "\u6E2F\u6FB3\u5C45\u6C11\u6765\u5F80\u5185\u5730\u901A\u884C\u8BC1";
  IdTypeEnum[IdTypeEnum["\u53F0\u6E7E\u5C45\u6C11\u6765\u5F80\u5185\u5730\u901A\u884C\u8BC1"] = 11] = "\u53F0\u6E7E\u5C45\u6C11\u6765\u5F80\u5185\u5730\u901A\u884C\u8BC1";
  IdTypeEnum[IdTypeEnum["\u6E2F\u6FB3\u53F0\u5C45\u6C11\u8EAB\u4EFD\u8BC1"] = 12] = "\u6E2F\u6FB3\u53F0\u5C45\u6C11\u8EAB\u4EFD\u8BC1";
  IdTypeEnum[IdTypeEnum["_\u6E2F\u6FB3\u53F0\u5C45\u6C11\u8EAB\u4EFD\u8BC1"] = 13] = "_\u6E2F\u6FB3\u53F0\u5C45\u6C11\u8EAB\u4EFD\u8BC1";
  IdTypeEnum[IdTypeEnum["\u793E\u4F1A\u4FDD\u969C\u53F7"] = 14] = "\u793E\u4F1A\u4FDD\u969C\u53F7";
  IdTypeEnum[IdTypeEnum["\u6E2F\u6FB3\u53F0\u5C45\u6C11\u5C45\u4F4F\u8BC1"] = 15] = "\u6E2F\u6FB3\u53F0\u5C45\u6C11\u5C45\u4F4F\u8BC1";
  IdTypeEnum[IdTypeEnum["\u6280\u672F\u76D1\u7763\u5C40\u4EE3\u7801"] = 20] = "\u6280\u672F\u76D1\u7763\u5C40\u4EE3\u7801";
  IdTypeEnum[IdTypeEnum["\u8425\u4E1A\u6267\u7167"] = 21] = "\u8425\u4E1A\u6267\u7167";
  IdTypeEnum[IdTypeEnum["\u884C\u653F\u673A\u5173"] = 22] = "\u884C\u653F\u673A\u5173";
  IdTypeEnum[IdTypeEnum["\u793E\u4F1A\u56E2\u4F53"] = 23] = "\u793E\u4F1A\u56E2\u4F53";
  IdTypeEnum[IdTypeEnum["\u519B\u961F"] = 24] = "\u519B\u961F";
  IdTypeEnum[IdTypeEnum["\u6B66\u8B66"] = 25] = "\u6B66\u8B66";
  IdTypeEnum[IdTypeEnum["\u4E0B\u5C5E\u673A\u6784"] = 26] = "\u4E0B\u5C5E\u673A\u6784";
  IdTypeEnum[IdTypeEnum["\u57FA\u91D1\u4F1A"] = 27] = "\u57FA\u91D1\u4F1A";
  IdTypeEnum[IdTypeEnum["\u767B\u8BB0\u8BC1\u4E66"] = 31] = "\u767B\u8BB0\u8BC1\u4E66";
  IdTypeEnum[IdTypeEnum["\u5916\u56FD\u4EBA\u6C38\u4E45\u5C45\u7559\u8BC1"] = 33] = "\u5916\u56FD\u4EBA\u6C38\u4E45\u5C45\u7559\u8BC1";
  IdTypeEnum["\u6B66\u8B66\u8BC1"] = "A1";
  IdTypeEnum["\u53F0\u80DE\u8BC1"] = "A2";
  IdTypeEnum["\u5176\u4ED6(\u673A\u6784)"] = "B1";
  IdTypeEnum["\u7EC4\u7EC7\u673A\u6784\u4EE3\u7801\u8BC1"] = "B2";
})(IdTypeEnum || (IdTypeEnum = {}));