import { SignFlagEnum } from "./CommonEnum";
interface IIF010048Params {
    /**
     * 需要登录或签约的资金账号
     */
    fundAccount: string;
    /**
     * 资金账户密码
     */
    password?: string;
    /**
     * 是否签约
     */
    needSign: SignFlagEnum;
    /**
     * 失效时长 单位：秒
     */
    expiredSeconds: string;
}
/**
 * 资金账号交易密码验证并签约
 * @returns
 */
export declare const IF010048: (params: IIF010048Params) => Promise<any>;
export {};
